# Contributing

Thanks for being willing to contribute!

**Working on your first Pull Request?** You can learn how from this _free_
series [How to Contribute to an Open Source Project on GitHub](https://egghead.io/courses/how-to-contribute-to-an-open-source-project-on-github)

## Project setup

1.  Fork and clone the repo
2.  Install dependencies by running `npm ci`
3.  If the prepare script didn't run, execute the command `npm run prepare` to set up husky
4.  Validate the project by running `npm run validate`
5.  Create a branch for your PR with `git checkout -b pr/your-branch-name`

## Committing and Pushing changes

### Validate Code

Please make sure to validate the code by running the `npm run validate` script. While the pipeline will make this check, it's better to verify this locally for a faster feedback loop. If you ran the prepare script from the project setup section then this should automatically happen on commit via husky.

### Format Commit Message for Semantic Release

This repository uses Semantic Release to determine and tag versions for package release. If you don't format commit messages correctly, your merges WILL NOT trigger a new release version. To make this easy, you can run the command `npx git-cz` to use Commitizen's interactive commit generator to create commit messages that match Semantic Release's [expected commit message format](https://github.com/semantic-release/semantic-release#commit-message-format). In order to avoid losing these commit messages in a squash merge, best practice is to rebase your merge's changes into a single commit generated by Commitizen.

### Rebase your merge's changes into a single standard commitizen commit

The general approach is to take all your commits for a set of changes associated with a merge and squash them into a single structured commit that will give the pipeline the ability to generate the correct Semantic version number for the output package. This process should be completed just prior to merging your code and after all work is complete.

1. Setup empty placeholder commit - This will be used as the main commit. All other commits will be squashed into this commit during the rebase squash in the next step: `npx git-cz --allow-empty`

2. Rebase squash - [Learn about Rebasing](https://www.atlassian.com/git/tutorials/rewriting-history/git-rebase)

3. Next push the single commit to the remote branch: `git push --force-with-lease`

4. Now create a pr for the branch. It should have just the one commit you pushed up. When this pr goes in, it will create the correct versioned package artifact file based off what was selected in the original Commitizen commit.
